{$A-,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y-}
{$M 65520,0,655360}
Program JJSorba;

Const
     MaxN=10001;
     MaxV=201;
     FINName = 'sorba.be';
     FOUtName='sorba.ki';

Type
    TLadaI=0..MaxN+MaxV+1;
    TVarosI=0..MaxV;

Var
   Cel:array[TLadaI] of TVarosI;
   EuUt:array[TLadaI] of TLadaI;
   EuLen:TLadaI;

   Fok:array[TVarosI] of TLadaI;
   Start,FirstId:array[TVarosI] of TLadaI;
   LadaCount:TLadaI;
   VarosCount:TVarosI;

Procedure Load;
Var
   f:text;
   i:integer;

Begin
     Assign(f,FINName);
     REset(f);
     REadln(f,LadaCount,VarosCount);
     for i := 1 to VarosCount do Fok[i] := 0;
     for i := 1 to LadaCount do Begin
         Read(f,Cel[i]);
         Inc(Fok[Cel[i]]);
     End;
     Close(f);
End;


Procedure FindStart;
Var
   i:integer;
   n:TLadaI;

Begin
     n := 1;
     for i := 1 to VarosCount do Begin
         Start[i] := n;
         n := n + Fok[i];
     End;
     Start[VarosCount+1]:=n;
     FirstId := Start;
End;

Var
   NextStart:integer;


Function FindFirstId(v:TVarosI):TLadaI;
Var
   fi:TLadaI;

Begin
     fi := FirstId[v];
     While (fi<Start[v+1]) AND (Cel[fi]=v) do Inc(fi);
     FirstId[v]:=fi;
     FindFirstId:=fi;
End;

Function FindNextStart:TVarosI;

Begin
     While (NextStart<=VarosCount) AND (FindFirstId(NextStart)>=Start[NextStart+1]) do
           Inc(NextStart);
     FIndNextStart := NextStart;
End;

Var
   mbstv:array[TLadaI] of TVarosI;
   mbstld:array[TLadaI]of TLadaI;
   stp:TLadaI;

{

           While (FindFirstId(mbstv[stp]) < Start[mbstv[stp]+1]) do Begin
                 mbstld[stp] := FirstId[mbstv[stp]];
                 Inc(FirstId[mbstv[stp]]);
                 mbstv[stp+1]:=Cel[mbstld[stp]];
                 Inc(stp);
                 goto
                 Dec(stp);
                 Inc(EuLen);
                 EuUt[EuLen] := mbstld[stp];
           End;
}

Procedure MBej;

Begin
     While (stp>0) do Begin
           If (FindFirstId(mbstv[stp]) < Start[mbstv[stp]+1]) then Begin
              {up}
              mbstld[stp] := FirstId[mbstv[stp]];
              Inc(FirstId[mbstv[stp]]);
              mbstv[stp+1]:=Cel[mbstld[stp]];
              Inc(stp);
           End Else Begin
           {go downwards}
               Dec(stp);
               Inc(EuLen);
               EuUt[EuLen] := mbstld[stp];
           End;

     End;
End;


Procedure FindUT;

Var
   clada:TLadaI;
   cvaros:TVarosI;
   euLast,euBefuzNext:TLadaI;

Begin
     NextStart := 1;
     EuLen := 0;
     While (FindNextStart <= VarosCount) do Begin
           {uj komponens indul az eu utban}
           cvaros := NextStart;
           clada := FindFirstId(NextStart);
           Inc(FirstId[nextstart]);
{           EuBefuzNext := EuNext[EuLast];}
           Inc(EuLen);
           EuUt[EuLen] := clada;

           mbstld[0] := 0;
           stp := 1;
           mbstv[stp] := cel[clada];

           While (stp>0) do Begin
                 If (FindFirstId(mbstv[stp]) < Start[mbstv[stp]+1]) then Begin
                    {up}
                    mbstld[stp] := FirstId[mbstv[stp]];
                    Inc(FirstId[mbstv[stp]]);
                    mbstv[stp+1]:=Cel[mbstld[stp]];
                    Inc(stp);
                 End Else Begin
                    {go downwards}
                    Dec(stp);
                    Inc(EuLen);
                    EuUt[EuLen] := mbstld[stp];
                 End;
           End;

{           Inc(EuLen);
           EuUt[EuLen]:=0; stp=0 megcsinalja}
     End;
End;


Procedure Dump;
Var
   f:text;
   last:TLadaI;
   i:TLadaI;

Begin
     Assign(f,FOUtName);
     REWrite(f);
     Writeln(f,EuLen);
     last := 0;
     for i := 1 to EuLen do
         Begin
         Writeln(f,EuUt[i],' ',last);
         last := EuUt[i];
         End;
     Close(f);
End;

Begin
     Load;
     FindStart;
     FindUt;
     Dump;
End.

