{$A+,B-,D-,E+,F-,G+,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y-}
{$M 65520,0,655360}
Program Sorba;
Const
  MaxN=10000;
  MaxV=200;
Type
  Pont=0..MaxV;
  Graf=Array[1..MaxV,1..MaxV] Of Boolean;
Var
  N,       { a ladak szama }
  V:Word;  { a varosok szama }
  L:Array[1..MaxN] of 0..MaxV;

  G:Graf;  { az input graf }
  Fok,
  Hany,
  Ei,
  Veg:Array[0..MaxV] Of Word;
  Komp:Word;
  i,j,k:Word;
  KiF:Text;

Procedure BeOlvas;
  Var i,j:Word;
    BeF:Text;
  Begin
    Assign(BeF,'sorba.be'); Reset(BeF);
    ReadLn(BeF,N, V);
    For i:=1 To V Do Begin
      Fok[i]:=0;
      Hany[i]:=0;
      For j:=1 To V Do G[i,j]:=False;
    End;
    For i:=1 To N Do Begin
      Read(BeF,L[i]);
      Inc(Hany[L[i]]);
    End;
    Close(BeF);
  End {Beolvas};

Procedure KiIr;
  Var p1:Word;

  Begin
    Assign(KiF,'sorba.ki'); Rewrite(KiF);
    Close(KiF);
  End{KiIr};

Procedure Komponens;
  Var Feher:Array[1..MAxV] of Boolean;
    i:Word;
  Procedure MelyBejar(p:Pont);
    Var q:Word;
    Begin
      Feher[p]:=False;
      For q:=1 To V Do Begin
        If G[p,q] And Feher[q] Then
          MelyBejar(q)
      End;
    End{MelyBejar};
Begin
  Komp:=0;
  For i:=1 To V Do Feher[i]:=True;
  For i:=1 To V Do
    If Feher[i] And (Fok[i]>0) Then Begin
      Inc(Komp);
      MelyBejar(i);
    End;
End{Komponens};

Procedure KorKeres(i:Word);
Var
  k,j,ind:Word;
  S:Array[0..MaxN] of 0..MaxN;
  Van:Boolean;
Begin{KorKeres}
  ind:=0;
  k:=Ei[i]; Van:=True;
  While True Do Begin
    Inc(ind); S[ind]:=k;
    j:=L[k];
    Dec(Fok[i]);
    If Fok[i]>0 Then Begin
      Repeat
        Inc(k);
      Until Not (L[k]=i);
      Ei[i]:=k
    End;
    If Fok[j]=0 Then
      Break
    Else Begin
      i:=j; k:=Ei[i];
    End;
  End{while};

  WriteLn(KiF, S[ind],' ',0);
  For k:=Ind Downto 2 Do Begin
    WriteLn(KiF, S[k-1],' ',S[k]);
  End;
  WriteLn(KiF, 0,' ',S[1]);
End{KorKeres};

Begin{Program}
  Beolvas;

  Veg[0]:=0;
  Veg[1]:=Hany[1];
  Ei[1]:=0;
  For i:=2 To V Do Begin
    Veg[i]:=Veg[i-1]+Hany[i];
    Ei[i]:=0;
  End;
  For k:=1 To N Do begin
    j:=L[k];
    If ((Veg[j-1]>=k)Or(k>Veg[j])) Then Begin
      i:=1;
      While k>Veg[i] Do Inc(i);
      G[i,j]:=True;
      Inc(Fok[i]);
      If Ei[i]=0 Then Ei[i]:=k
    End;
  End;
{Init}
  Komponens;
  For i:=1 To V Do Komp:=Komp+Fok[i];
  Assign(KiF,'sorba.ki'); Rewrite(KiF);
  WriteLn(Kif, Komp);

  i:=1;
  While True Do Begin
    While (V>=i)And(Fok[i]=0) Do Inc(i);
    If (i>V) Then Break;
    KorKeres(i);
  End;
  Close(KiF);
End.
